SYS_TGKILL(9)

NAME
sys_tgkill - send signal to one specific thread

SYNOPSIS

long sys_tgkill (int tgid, int pid, int sig);

ARGUMENTS

tgid
    the thread group ID of the thread

pid the PID of the thread

sig signal to be sent

DESCRIPTION

This syscall also checks the tgid and returns -ESRCH even if the PID exists but it's not belonging to the target process anymore. This method solves the problem of threads exiting and PIDs getting reused.